# Tabulator

The Tabulator project is a generic data browser and editor. Using outline and table modes, it provides a way to browse RDF data on the web. RDF is the standard for inter-application data exchange

You can use it in various ways:

# As a Browser Extension

[Firefox](https://github.com/linkeddata/tabulator-firefox)

[Chrome](https://github.com/linkeddata/tabulator-chrome)

# As a javascript shim

make the file mashlib.js

    <script type="text/javascript" src="https://w3.scripts.mit.edu/tabulator/js/mashup/mashlib.js"></script>
    
### About it:

*   [
        Tabulator extension tutorial](http://dig.csail.mit.edu/2007/tab/tabtutorial.html)
*   [Screencast - Editing data](http://dig.csail.mit.edu/2007/tab/tutorial/editing.mov)
*   [
	How to use the tabulator](http://dig.csail.mit.edu/2005/ajar/ajaw/Help.html)
*   [
	About the tabulator](http://dig.csail.mit.edu/2005/ajar/ajaw/About.html)
*   [
	Using queries and SPARQL in tabulator](http://dig.csail.mit.edu/2005/ajar/ajaw/tut/querytut.html)
*   [
	Tabulator map view](http://dig.csail.mit.edu/2005/ajar/ajaw/tut/tabmap.html)
*   [
	How to use Calendar and Timeline View](http://dig.csail.mit.edu/2005/ajar/ajaw/tut/calHelp.html)

### Publications:

*   Berners-Lee, T., Hollenbach, J., Lu, K., Presbrey, J., Pru d'ommeaux, E. and schraefel, m. c. , [
	_Tabulator Redux: Writing Into the Semantic Web_](http://eprints.ecs.soton.ac.uk/14773/1/tabulatorWritingTechRep.pdf), unpublished, 2007.
                [[eprints]](http://eprints.ecs.soton.ac.uk/14773/)
*   Berners-Lee et. al., [
	_Tabulator: Exploring and Analyzing linked data on the Semantic Web_](http://swui.semanticweb.org/swui06/papers/Berners-Lee/Berners-Lee.pdf),
	    Procedings of the [The 3rd International Semantic Web User Interaction Workshop (SWUI06)](http://swui.semanticweb.org/swui06)
	    workshop, Athens, Georgia, 6 Nov 2006.
*   [Slides](http://dig.csail.mit.edu/2007/Talks/0511-tab-tbl/)
	 from talk on tabulator (including screen shots).

### For Developers:

*   [
	Developer notes](http://dig.csail.mit.edu/2005/ajar/ajaw/Developer.html)
*   [
	Issue tracker - add suggested features, bug reports.](http://dig.csail.mit.edu/issues/tabulator/)
*   experimental [issues tracker in data wiki](http://dig.csail.mit.edu/2007/wiki/tabulator#project) (RDF data; use Tabulator to view!)
*   [
        Semantic Web user Interaction mailing list](http://lists.w3.org/Archives/Public/public-semweb-ui/2006Sep/)
*   [
	Longer term to-do agenda](http://dig.csail.mit.edu/2005/ajar/ajaw/ToDo.html)
*   [
	Tabulator people at MIT](http://dig.csail.mit.edu/2005/ajar/ajaw/people/Overview.html)

Thanks to all those who have provided feedback, code patches etc.

#### Data links

Only if you have a data browser, such as ffox+Tabulator extension, installed.

*   [Tabulator project](http://dig.csail.mit.edu/2005/ajar/ajaw/data#Tabulator)
